<?php

namespace PurchasingBundle\Repository;


use PurchasingBundle\Entity\Coupon;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;
use Psr\Log\LoggerInterface;

/**
 * CouponRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CouponRepository extends SchemaEntityRepository {

    const DEFAULT_MAX_RESULTS = 50;

    /** @var LoggerInterface $logger */
    private $logger;


    /**
     * CouponRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Coupon::class);

        $this->logger = $logger;
    }

    /**
     * @param int $page
     * @param null|string $suggest
     * @param int $maxResults
     * @param string $sort
     * @return array|\Doctrine\ORM\Tools\Pagination\Paginator
     */
    public function findAllPaginatedCoupons ($page=1, ?string $suggest, $maxResults=self::DEFAULT_MAX_RESULTS, $sort='DESC') {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('c')
            ->from('PurchasingBundle:Coupon', 'c');

        if (!is_null($suggest)) {
            $qb->where('c.code LIKE :code')
                ->setParameter('code', '%'.$suggest.'%');
        }

        $qb->orderBy('c.id',$sort);

        $results = array();

        try {
            $query   = $qb->getQuery();
            $results = $this->paginate($query,$page,$maxResults);
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all coupons", $exception);
        }

        return $results;

    }

    /**
     * @return array|mixed
     */
    public function findAllSpecials () {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('c')
            ->from('PurchasingBundle:Coupon', 'c')
            ->where('c.type = :type')
            ->setParameter('type',Coupon::TYPE_SPECIAL)
            ->orderBy('c.id','DESC');
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all special coupons", $exception);
        }

        return $results;
    }

    /**
     * @param Coupon $coupon
     * @return mixed|null
     */
    public function findCountCouponsByType (Coupon &$coupon) {

        $qb = $this->getEntityManager()->createQuery(
            'SELECT count(0) AS counted 
                  FROM PurchasingBundle:Coupon coupon
                  WHERE coupon.type = :coupon_type'
        )->setParameter('coupon_type', $coupon->getType());

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get count coupons by type", $exception);
        }

        return $result;
    }


    /**
     * @return mixed|null
     */
    public function findCountCoupons () {

        $qb = $this->getEntityManager()->createQuery(
            'SELECT count(0) AS counted 
                  FROM PurchasingBundle:Coupon coupon'
        );

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get count coupons", $exception);
        }

        return $result;
    }

    /**
     * @param $code
     * @return mixed|null
     */
    public function findByCode ($code) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('c')
            ->from('PurchasingBundle:Coupon', 'c')
            ->where('c.code = :code AND c.isDisabled != 1')
            ->setParameter('code', $code)
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get coupon by code", $exception);
        }

        return $result;
    }

}
